hdu1026 Ignatius and the Princess I(BFS+优先队列)

题目链接http://acm.hdu.edu.cn/showproblem.php?pid=1026

Ignatius and the Princess I

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 13944    Accepted Submission(s): 4381

Special Judge

Problem Description

The Princess has been abducted by the BEelzebub feng5166, our hero Ignatius has to rescue our pretty Princess. Now he gets into feng5166‘s castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrinth
is a N*M two-dimensional array which left-top corner is (0,0) and right-bottom corner is (N-1,M-1). Ignatius enters at (0,0), and the door to feng5166‘s room is at (N-1,M-1), that is our target. There are some monsters in the castle, if Ignatius meet them,
he has to kill them. Here is some rules:

1.Ignatius can only move in four directions(up, down, left, right), one step per second. A step is defined as follow: if current position is (x,y), after a step, Ignatius can only stand on (x-1,y), (x+1,y), (x,y-1) or (x,y+1).

2.The array is marked with some characters and numbers. We define them like this:

. : The place where Ignatius can walk on.

X : The place is a trap, Ignatius should not walk on it.

n : Here is a monster with n HP(1<=n<=9), if Ignatius walk on it, it takes him n seconds to kill the monster.

Your task is to give out the path which costs minimum seconds for Ignatius to reach target position. You may assume that the start position and the target position will never be a trap, and there will never be a monster at the start position.

Input

The input contains several test cases. Each test case starts with a line contains two numbers N and M(2<=N<=100,2<=M<=100) which indicate the size of the labyrinth. Then a N*M two-dimensional array follows, which describe the whole
labyrinth. The input is terminated by the end of file. More details in the Sample Input.

Output

For each test case, you should output "God please help our poor hero." if Ignatius can‘t reach the target position, or you should output "It takes n seconds to reach the target position, let me show you the way."(n is the minimum
seconds), and tell our hero the whole path. Output a line contains "FINISH" after each test case. If there are more than one path, any one is OK in this problem. More details in the Sample Output.

Sample Input

5 6
.XX.1.
..X.2.
2...X.
...XX.
XXXXX.
5 6
.XX.1.
..X.2.
2...X.
...XX.
XXXXX1
5 6
.XX...
..XX1.
2...X.
...XX.
XXXXX.

Sample Output

It takes 13 seconds to reach the target position, let me show you the way.
1s:(0,0)->(1,0)
2s:(1,0)->(1,1)
3s:(1,1)->(2,1)
4s:(2,1)->(2,2)
5s:(2,2)->(2,3)
6s:(2,3)->(1,3)
7s:(1,3)->(1,4)
8s:FIGHT AT (1,4)
9s:FIGHT AT (1,4)
10s:(1,4)->(1,5)
11s:(1,5)->(2,5)
12s:(2,5)->(3,5)
13s:(3,5)->(4,5)
FINISH
It takes 14 seconds to reach the target position, let me show you the way.
1s:(0,0)->(1,0)
2s:(1,0)->(1,1)
3s:(1,1)->(2,1)
4s:(2,1)->(2,2)
5s:(2,2)->(2,3)
6s:(2,3)->(1,3)
7s:(1,3)->(1,4)
8s:FIGHT AT (1,4)
9s:FIGHT AT (1,4)
10s:(1,4)->(1,5)
11s:(1,5)->(2,5)
12s:(2,5)->(3,5)
13s:(3,5)->(4,5)
14s:FIGHT AT (4,5)
FINISH
God please help our poor hero.
FINISH

网上说用stack输出路径

可是stack还不会用,参照了大神的思路,只要倒着搜索就可以不用栈了,用二维数组记录每一步的前驱再往回打印就可以输出路径了;

本题用到了优先队列,时间小的先出队,对优先队列有疑惑的同学请移步 :STL优先队列详解

【源代码】

#include <stdio.h>
#include <cstring>
#include <queue>
using namespace std;
#define maxn 110
char map[110][110];
bool vis[maxn][maxn];
struct point
{
    int x,y;int times;
    friend bool operator <(point a,point b)
    {
        return a.times>b.times;  //重载小于号,使得时间小的先出队列;
    }
};
struct Pre{
    int px,py;
}pre[maxn][maxn];
int r,c;
int dx[4]={0,0,1,-1};
int dy[4]={1,-1,0,0};
bool inborder(point a)
{
    if(a.x<0||a.y<0||a.x>r-1||a.y>c-1)
        return false;
    return true;
}
void BFS(int x, int y)
{
    pre[x][y].px=-1;
    vis[x][y]=1;
    point st;
    st.x=x,st.y=y;
    if(map[st.x][st.y]!='.')
        st.times=(map[st.x][st.y]-'0');
    else
        st.times=0;
    priority_queue<point>Q;
    while(!Q.empty())
        Q.pop();
    Q.push(st);
    while(!Q.empty())
    {
        point now=Q.top();
        Q.pop();
        if(now.x==0&&now.y==0)
        {
            int key=1;
            printf("It takes %d seconds to reach the target position, let me show you the way.\n",now.times);
            while(pre[now.x][now.y].px!=-1)//循环找前驱,直到终点
            {
                int tx=pre[now.x][now.y].px;
                int ty=pre[now.x][now.y].py;
                if(map[tx][ty]=='.')
                {
                    printf("%ds:(%d,%d)->(%d,%d)\n",key++,now.x,now.y,tx,ty);
                }
                else//打怪耗时
                {
                    printf("%ds:(%d,%d)->(%d,%d)\n",key++,now.x,now.y,tx,ty);
                    int tt=map[tx][ty]-'0';
                    while(tt--)
                        printf("%ds:FIGHT AT (%d,%d)\n",key++,tx,ty);
                }
                now.x=tx;//将当前前驱作为起始
                now.y=ty;
            }
            //printf("%ds:(%d,%d)->(%d,%d)\n",key++,now.x,now.y,r-1,c-1);
            return ;
        }
        else
        {
            point next;
            for(int i=0;i<4;i++)
            {
                next.x=now.x+dx[i];
                next.y=now.y+dy[i];
                next.times=now.times;
                if(map[next.x][next.y]=='X'||vis[next.x][next.y]||!inborder(next))
                    continue;
                else
                {
                    vis[next.x][next.y]=1;
                    if(map[next.x][next.y]=='.')
                    {
                        next.times+=1;
                    }
                    else
                    {
                        next.times+=(map[next.x][next.y]-'0'+1);//除了打怪耗时,还有走到该坐标的耗时故+1;
                    }
                    pre[next.x][next.y].px=now.x;//记录前驱
                    pre[next.x][next.y].py=now.y;
                    Q.push(next);
                }
            }
        }
    }
    printf("God please help our poor hero.\n");
}
void init()
{
    memset(vis,0,sizeof(vis));
    memset(map,'\0',sizeof(map));
    memset(pre,0,sizeof(pre));
}
int main()
{
    //int r,c;
    while(~scanf("%d%d",&r,&c))
    {
        init();
        for(int i=0;i<r;i++)
            scanf("%s",map[i]);
        BFS(r-1,c-1);//从右下角搜索
        puts("FINISH");
    }
    return 0;
}
时间: 2024-10-29 10:46:00

hdu1026 Ignatius and the Princess I(BFS+优先队列)的相关文章

HDU ACM 1026 Ignatius and the Princess I -&gt; BFS+优先队列+路径打印

分析:在BFS中使用优先队列即可获取最小值. #include<iostream> #include<queue> using namespace std; //BFS+优先队列(打印路径) #define N 101 struct Node //节点 { int x,y,time; friend bool operator<(const Node& a,const Node& b) //有限队列根据时间做依据 { return a.time>b.tim

HDU1026 Ignatius and the Princess I

问题链接:HDU1026 Ignatius and the Princess I. 题意简述:从矩阵的左上角走到右下角所需的最短时间,并且要求输出走的过程.矩阵中"."是可以走的,"X"是墙,n(数字1-9)是怪兽,需要战斗数字所示的时间.对于每个测试实例,先输入n和m,分别表示行数和列数,然后输入矩阵. 问题分析:显然求最短路径问题用BFS,另外由于有怪兽,所以搜索过程需要使用优先队列.一个典型的用分支限界法解决的问题.最小路径上每个点到出发点距离应该是最小的.

hdu 1026 Ignatius and the Princess I(bfs搜索+输出路径)

题目来源:hdu-1026 Ignatius and the Princess I Ignatius and the Princess I Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 14677 Accepted Submission(s): 4653 Special Judge Problem Description The Princ

HDU1026 Ignatius and the Princess I 【BFS】+【路径记录】

Ignatius and the Princess I Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11710    Accepted Submission(s): 3661 Special Judge Problem Description The Princess has been abducted by the BEelzeb

HDU 1026 Ignatius and the Princess I(BFS+路径输出)

Ignatius and the Princess I Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 19800    Accepted Submission(s): 6452Special Judge Problem Description The Princess has been abducted by the BEelzebub

HDU 1026 Ignatius and the Princess I(BFS+记录路径)

Ignatius and the Princess I Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 15576    Accepted Submission(s): 4937 Special Judge Problem Description The Princess has been abducted by the BEelzeb

hdu 1026 Ignatius and the Princess I (bfs打印路径)

Problem Description The Princess has been abducted by the BEelzebub feng5166, our hero Ignatius has to rescue our pretty Princess. Now he gets into feng5166's castle. The castle is a large labyrinth. To make the problem simply, we assume the labyrint

HDU 1026 Ignatius and the Princess I(优先队列+打印路径)

题意:n*m的迷宫,从(0,0)到(n-1,m-1),遇到怪物停留怪物所在方格中的数字个单位时间,求最短时间并打印路径: 思路:用bfs先搜最短路,搜最短路时一定要用优先队列,不然结果不对:在通过保存上一步的方法保存路径,到达终点时,将路径查询出来,遇到怪物是位置不变: #include<cstdio> #include<cstring> #include<queue> #include<algorithm> using namespace std; int

hdu - 1026 Ignatius and the Princess I (bfs+dfs)

http://acm.hdu.edu.cn/showproblem.php?pid=1026 求起点到终点的最少花费,输出路径的时候麻烦一点,借鉴了别人的思路,用dfs 递归打印出路径. 用额外一个二维数组标记当前点的前驱,因为点是一个坐标,那么可以用 s=x*m+y 映射成一个点就可以了. 这样知道这个数值在求出坐标的话,x=s/m,y=s%m. 1 #include <iostream> 2 #include <cstdio> 3 #include <cmath>